-- ImprovedForts_Data
-- Author: thecrazyscotsman
-- DateCreated: 8/2/2017 10:01:10 AM
--------------------------------------------------------------
INSERT INTO Types (Type, Kind)
	VALUES
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'KIND_ABILITY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'KIND_ABILITY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'KIND_ABILITY');

INSERT INTO TypeTags (Type, Tag)
	VALUES
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'CLASS_RECON'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'CLASS_MELEE'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'CLASS_RANGED'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'CLASS_ANTI_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'CLASS_SIEGE'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'CLASS_HEAVY_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'CLASS_HEAVY_CHARIOT'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'CLASS_LIGHT_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'CLASS_LIGHT_CHARIOT'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'CLASS_RANGED_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'CLASS_RECON'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'CLASS_MELEE'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'CLASS_RANGED'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'CLASS_ANTI_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'CLASS_SIEGE'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'CLASS_HEAVY_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'CLASS_HEAVY_CHARIOT'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'CLASS_LIGHT_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'CLASS_LIGHT_CHARIOT'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'CLASS_RANGED_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'CLASS_RECON'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'CLASS_MELEE'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'CLASS_RANGED'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'CLASS_ANTI_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'CLASS_SIEGE'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'CLASS_HEAVY_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'CLASS_HEAVY_CHARIOT'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'CLASS_LIGHT_CAVALRY'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'CLASS_LIGHT_CHARIOT'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'CLASS_RANGED_CAVALRY');

UPDATE Units
Set Cost = 150, BuildCharges = 4
WHERE UnitType = 'UNIT_MILITARY_ENGINEER';
		
INSERT INTO UnitAbilities (UnitAbilityType, Name, Description, Inactive)
	VALUES
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'LOC_ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT_NAME', 'LOC_ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT_DESCRIPTION', 0),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'LOC_ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL_NAME', 'LOC_ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL_DESCRIPTION', 0),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'LOC_ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH_NAME', 'LOC_ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH_DESCRIPTION', 0);
		
INSERT INTO UnitAbilityModifiers (UnitAbilityType, ModifierId)
	VALUES
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_SIGHT', 'DEFENSIVEIMPROVEMENT_BONUS_SIGHT'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_BONUS_HEAL', 'DEFENSIVEIMPROVEMENT_BONUS_HEAL'),
		('ABILITY_DEFENSIVE_IMPROVEMENT_REVEAL_STEALTH', 'DEFENSIVEIMPROVEMENT_REVEAL_STEALTH');

UPDATE Buildings
SET DefenseModifier = 6
WHERE BuildingType = 'BUILDING_ALHAMBRA';

INSERT INTO BuildingModifiers (BuildingType, ModifierId)
	VALUES
		('BUILDING_ALHAMBRA', 'ALHAMBRA_ADD_MILITARY_ENGINEER_CHARGES');

INSERT INTO Improvement_ValidFeatures (ImprovementType, FeatureType)
	VALUES
		('IMPROVEMENT_GREAT_WALL', 'FEATURE_FOREST'),
		('IMPROVEMENT_GREAT_WALL', 'FEATURE_FLOODPLAINS');
		
INSERT INTO Modifiers (ModifierId, ModifierType, SubjectRequirementSetId)
	VALUES
		('DEFENSIVEIMPROVEMENT_BONUS_SIGHT', 'MODIFIER_PLAYER_UNIT_ADJUST_SIGHT', 'IMPROVEMENT_IS_DEFENSIVE'),
		('DEFENSIVEIMPROVEMENT_BONUS_HEAL', 'MODIFIER_PLAYER_UNIT_ADJUST_HEAL_PER_TURN', 'IMPROVEMENT_IS_DEFENSIVE'),
		('DEFENSIVEIMPROVEMENT_REVEAL_STEALTH', 'MODIFIER_PLAYER_UNIT_ADJUST_SEE_HIDDEN', 'IMPROVEMENT_IS_DEFENSIVE'),
		('ALHAMBRA_ADD_MILITARY_ENGINEER_CHARGES', 'MODIFIER_PLAYER_UNITS_ADJUST_BUILDER_CHARGES', 'UNIT_IS_MILITARY_ENGINEER');

INSERT INTO ModifierArguments (ModifierId, Name, Value)
	VALUES
		('DEFENSIVEIMPROVEMENT_BONUS_SIGHT', 'Amount', 1),
		('DEFENSIVEIMPROVEMENT_BONUS_HEAL', 'Amount', 5),
		('DEFENSIVEIMPROVEMENT_BONUS_HEAL', 'Type', 'ALL'),
		('DEFENSIVEIMPROVEMENT_REVEAL_STEALTH', 'SeeHidden', 'true'),
		('ALHAMBRA_ADD_MILITARY_ENGINEER_CHARGES', 'Amount', 2);

INSERT INTO RequirementSets (RequirementSetId, RequirementSetType)
	VALUES
		('IMPROVEMENT_IS_DEFENSIVE', 'REQUIREMENTSET_TEST_ANY'),
		('PLOT_ADJACENT_TO_ALHAMBRA', 'REQUIREMENT_TEST_ALL'),
		('UNIT_IS_MILITARY_ENGINEER', 'REQUIREMENTSET_TEST_ALL');

INSERT INTO RequirementSetRequirements (RequirementSetId, RequirementId)
	VALUES
		('IMPROVEMENT_IS_DEFENSIVE', 'REQUIRES_FORT_IN_PLOT'),
		('IMPROVEMENT_IS_DEFENSIVE', 'REQUIRES_ROMANFORT_IN_PLOT'),
		('IMPROVEMENT_IS_DEFENSIVE', 'REQUIRES_GREATWALL_IN_PLOT'),
		('PLOT_ADJACENT_TO_ALHAMBRA', 'REQUIRES_PLOT_ADJACENT_TO_ALHAMBRA'),
		('UNIT_IS_MILITARY_ENGINEER', 'REQUIRES_UNIT_IS_MILITARY_ENGINEER');

INSERT INTO Requirements (RequirementId, RequirementType)
	VALUES
		('REQUIRES_FORT_IN_PLOT', 'REQUIREMENT_PLOT_IMPROVEMENT_TYPE_MATCHES'),
		('REQUIRES_ROMANFORT_IN_PLOT', 'REQUIREMENT_PLOT_IMPROVEMENT_TYPE_MATCHES'),
		('REQUIRES_GREATWALL_IN_PLOT', 'REQUIREMENT_PLOT_IMPROVEMENT_TYPE_MATCHES'),
		('REQUIRES_PLOT_ADJACENT_TO_ALHAMBRA', 'REQUIREMENT_PLOT_ADJACENT_BUILDING_TYPE_MATCHES'),
		('REQUIRES_UNIT_IS_MILITARY_ENGINEER', 'REQUIREMENT_UNIT_TYPE_MATCHES');

INSERT INTO RequirementArguments (RequirementId, Name, Value)
	VALUES
		('REQUIRES_FORT_IN_PLOT', 'ImprovementType', 'IMPROVEMENT_FORT'),
		('REQUIRES_ROMANFORT_IN_PLOT', 'ImprovementType', 'IMPROVEMENT_ROMAN_FORT'),
		('REQUIRES_GREATWALL_IN_PLOT', 'ImprovementType', 'IMPROVEMENT_GREAT_WALL'),
		('REQUIRES_PLOT_ADJACENT_TO_ALHAMBRA', 'BuildingType', 'BUILDING_ALHAMBRA'),
		('REQUIRES_UNIT_IS_MILITARY_ENGINEER', 'UnitType', 'UNIT_MILITARY_ENGINEER');

--==============================
--DLC COMPATIBILITY TRIGGERS
--==============================
--Alcazar Improvement
--------------------------------
UPDATE Improvements
SET Description = 'LOC_IMPROVEMENT_ALCAZAR_DESCRIPTION_TCS_MOD'
WHERE ImprovementType = 'IMPROVEMENT_ALCAZAR'
AND EXISTS (SELECT * FROM Improvements WHERE ImprovementType = 'IMPROVEMENT_ALCAZAR');
	
INSERT INTO RequirementSetRequirements (RequirementSetId, RequirementId)
SELECT 'IMPROVEMENT_IS_DEFENSIVE', 'REQUIRES_ALCAZAR_IN_PLOT'
WHERE EXISTS (SELECT * FROM Improvements WHERE ImprovementType = 'IMPROVEMENT_ALCAZAR');

INSERT INTO Requirements (RequirementId, RequirementType)
SELECT 'REQUIRES_ALCAZAR_IN_PLOT', 'REQUIREMENT_PLOT_IMPROVEMENT_TYPE_MATCHES'
WHERE EXISTS (SELECT * FROM Improvements WHERE ImprovementType = 'IMPROVEMENT_ALCAZAR');

INSERT INTO RequirementArguments (RequirementId, Name, Value)
SELECT 'REQUIRES_ALCAZAR_IN_PLOT', 'ImprovementType', 'IMPROVEMENT_ALCAZAR'
WHERE EXISTS (SELECT * FROM Improvements WHERE ImprovementType = 'IMPROVEMENT_ALCAZAR');